/*
 * Arduino Workbench tekyinblack 2020 - www.tekyinblack.com
 */
/*
 * setupAnalog - routine to initialise analog inputs
 * drawAnalogFig - handle analog display inputs and outputs
 * getAnalogReading - obtain raw figure from source
 * logicAnalogFig - display specific code for analog values
 */
#define LOWER_RESISTOR 68000  // update with the actual resistor value used to attenuate the input to the adc
#define UPPER_RESISTOR 430000 // here it is 430k and 68k. If not used, only change UPPER_RESISTOR to 0.
float analogConversion = 0.0405 ; //((UPPER_RESISTOR + LOWER_RESISTOR) / LOWER_RESISTOR) * 5 / 1024;
void setupAnalog() {
  
}
void drawAnalogFig(int itemNo) { 
  // routine to draw figure on screen for input voltage
  struct touchInfo newTouch;
  float pinValue = getAnalogReading(itemNo);
  if (workMode == MODE_NORMAL) {
      newTouch = logicAnalogFig(workScreens[itemNo][ITEMX], workScreens[itemNo][ITEMY], 5, pinValue, workScreens[itemNo][PARAM_2]);

  } else if (workMode == MODE_LARGE){
      newTouch = logicAnalogFig(workScreens[itemNo][ITEMXS], workScreens[itemNo][ITEMYS], 8, pinValue, workScreens[itemNo][PARAM_2]);

  } else if (workMode == MODE_FULLSCREEN){
      newTouch = logicAnalogFig(0,50, 14, pinValue, workScreens[itemNo][PARAM_2]);

  }
  registerTouch(itemNo, newTouch);
}

float getAnalogReading(int itemNo) {

  return analogConversion * analogRead(workScreens[itemNo][PARAM_1]);
}

struct touchInfo logicAnalogFig(int xval, int yval, int textSize, float value, int drawColour) {
  // draw analog value on screen
  char data[10];
  int newWidth = 5*6*textSize;   //  5 characters wide, each of 6 pixels wide times text multiplier
  int newHeight = 8*textSize ;   // 8 pixels wide times text multiplier
  dtostrf(value, 5, 2, data);
  tft.setTextSize(textSize);
  tft.setTextColor(drawColour, BLACK);
  tft.setCursor(xval, yval);
  tft.print(data);
  if (reDraw) {
    tft.setTextSize(5);
    tft.print("v");
  }
  return logicTouch(xval, xval + newWidth, yval, yval + newHeight);
}
